<?php /*	-----------------------------------	//
//	Projekt:	Tweets2Delicious				//
//	Autor:		Sergej Müller					//
//	Website:	http://ebiene.de				//
//	Datum:		August 2009						//
//																						//
//	Datei:		tweets2delicious.php			//
//	----------------------------------------	*/

/* ..............................................
..	modifications by Viktor Dite
..	viktor-dite.de
..
..	list of modifications: http://bit.ly/15j2z6
.. ..............................................*/


/* Tweets2Delicious Class */

class tweets2delicious {


	/**
  * @var  $delicious_user  string  Delicious username for import
  */

	var $delicious_user = '******';


	/**
  * @var  $password  string  Delicious password for import
  */

	var $delicious_pwd = '******';


	/**
  * @var  $twitter_user  string  Twitter user for export
  */

	var $twitter_user = '********';


	/**
  * tweets2delicious
  *
  * Konstruktor der Klasse
  *
  * @package  tweets2delicious.php
  * @author   Sergej Müller
  * @since    20.08.2009
  * @change   20.08.2009
  * @access		public
  */

	function tweets2delicious() {
		$this->save(
			$this->convert(
				$this->get()
			)
		);
	}


	/**
  * save
  *
  * Speichert Bookmarks bei Delicious
  *
  * @package  tweets2delicious.php
  * @author   Sergej Müller
  * @since    20.08.2009
  * @change   20.08.2009
  * @access		public
  * @param    array  $items  Array mit Elementen
  */

	function save($items) {
		/* Keine Bookmarks */
		if (!$items) {
			return false;
		}

		/* Keine Zugangdaten */
		if (!$this->delicious_user || !$this->delicious_pwd) {
			die('Delicious username or password empty!');
		}

		/* Elemente loopen */
		foreach($items as $item) {
	
	
	
	
	
	


//this is new
//fetch the title tag of the website
		  $urltitle = curl_init();
    		curl_setopt($urltitle, CURLOPT_URL, $item['url']);
    		curl_setopt($urltitle, CURLOPT_RETURNTRANSFER, 1);
    		curl_setopt($urltitle, CURLOPT_CONNECTTIMEOUT, 10);
    		$html = curl_exec($urltitle);
    		curl_close($urltitle);
    
    		preg_match('(<title([^>]*)>(.*)</?title[^>]*>)',$html, $title);
    	   
    	   //had problems with some titles - dont know why
		  if($title[2]=='') {$title[2]=$item['desc']; echo('title=desc');}		  
//end new







		  $url = sprintf(
		  	'https://api.del.icio.us/v1/posts/add?url=%s&description=%s&extended=%s&tags=%s&s&replace=yes&shared=yes',
		  	urlencode($item['url']),







//this is new
		  	urlencode(html_entity_decode($title[2])),
		  	urlencode($item['desc']),
//end new






		  	urlencode(implode(' ', $item['tags']))
		  );
			/* Verbindung aufbauen */
		  $ch = curl_init($url);
		  curl_setopt($ch, CURLOPT_HEADER, 0);
		  curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
		  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		  curl_setopt($ch, CURLOPT_USERPWD, $this->delicious_user. ':' .$this->delicious_pwd);
		  $return = curl_exec($ch);

		  /* Feedback ausgeben */
		  echo sprintf(
		  	'%s - %s<br />',
		  	$item['url'],
		  	(strstr($return, '<result code="done"') ? 'saved' : 'failed')
		  );

		  curl_close($ch);
		}

		/* Fertig */
		echo "Done!";
	}


	/**
  * get
  *
  * Liest den aktuellen Twitter-Stream aus
  *
  * @package  tweets2delicious.php
  * @author   Sergej Müller
  * @since    20.08.2009
  * @change   20.08.2009
  * @access		public
  * @return   array  $items  Array mit Elementen
  */

	function get() {
		/* Kein Twitter-Account? */
		if (!$this->twitter_user) {
			die('Twitter account empty!');
		}

		/* Wert initialisieren */
		$items = array();

		/* URL zusammenstellen */
		$url = sprintf(
			'http://search.twitter.com/search.json?from=%s&since=%2$s&until=%2$s&filter=links&rpp=100',
			$this->twitter_user,
			date('Y-m-d', strtotime("-1 day"))
		);

		/* Verbindung aufbauen */
		$ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
    $json = curl_exec($ch);
    curl_close($ch);

    /* Ausgabe dekodieren */
    $decode = json_decode($json);

    /* Ausgabe loopen */
    foreach($decode->results as $tweet) {
    	array_push($items, $tweet->text);
    }

    return $items;
	}


	/**
  * convert
  *
  * Speichert Bookmarks bei Delicious
  *
  * @package  tweets2delicious.php
  * @author   Sergej Müller
  * @since    20.08.2009
  * @change   20.08.2009
  * @access		public
  * @param    array  $tweets  Array mit Tweets
  * @return   array  $items   Array mit konvertierten Elementen
  */

	function convert($tweets) {
		/* Keine Tweets? */
		if (!$tweets) {
			return;
		}

		/* Wert initialisieren */
		$items = array();

		foreach ($tweets as $tweet) {
			/* Tweet als Array */
			$item = array();

			/* Tags auslesen */
			preg_match_all('/#([\\d\\w]+)/', $tweet, $matches);
			$item['tags'] = $matches[1];

			/* URL auslesen */
			preg_match('#(http|https|ftp)://[^ ]+#', $tweet, $matches);

			/* Keine Treffer? */
			if (!$matches[0]) {
				continue;
			}

			/* Link im Tweet */
			$url = $matches[0];

			/* Verbindung aufbauen */
			$ch = curl_init($matches[0]);
      curl_setopt($ch, CURLOPT_HEADER, true);
      curl_setopt($ch, CURLOPT_NOBODY, true);
      curl_setopt($ch, CURLOPT_TIMEOUT, 10);
      curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
      $response = curl_exec($ch);
      curl_close($ch);

			/* Redirect auslesen */
			preg_match('/Location: (.*)/', $response, $matches);

			/* Endgültiger Link */
			$item['url'] = (string) ($matches[1] ? $matches[1] : $url);

			/* Beschreibung auslesen */
			$tweet = //replies are not shown in the description
			preg_replace('!((http|https|ftp)://[^ ]+)|(\((^RT|RT\:|by|via|von)\s*?@[\w_]+)\)|(#)|@[\w_]+|(RT)+|(RT\:)+!', '', $tweet);
			//preg_replace('!((http|https|ftp)://.*$)|((^RT|by|via|von)\s*?@[a-z0-9_]+)|(#)!', '', $tweet);
			$tweet = trim(trim($tweet), '.;:-');
			$item['desc'] = (string) $tweet;

			/* Dem Array hinzufügen */
			if ($item['tags'] && $item['url'] && $item['desc']) {
				array_push($items, $item);
			}
		}

		return $items;
	}
}


/* Init class */
new tweets2delicious();
?>